// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package user

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// UserServiceClient is the client API for UserService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type UserServiceClient interface {
	Create(ctx context.Context, in *CreateArgs, opts ...grpc.CallOption) (*CreateResult, error)
	Remove(ctx context.Context, in *RemoveArgs, opts ...grpc.CallOption) (*RemoveResult, error)
	FindByID(ctx context.Context, in *FindByIDArgs, opts ...grpc.CallOption) (*FindByIDResult, error)
	FindByEmailAndPassword(ctx context.Context, in *FindByEmailAndPasswordArgs, opts ...grpc.CallOption) (*FindByEmailAndPasswordResult, error)
	ChangeStatus(ctx context.Context, in *ChangeStatusArgs, opts ...grpc.CallOption) (*ChangeStatusResult, error)
	ChangePass(ctx context.Context, in *ChangePassArgs, opts ...grpc.CallOption) (*ChangePassResult, error)
}

type userServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewUserServiceClient(cc grpc.ClientConnInterface) UserServiceClient {
	return &userServiceClient{cc}
}

func (c *userServiceClient) Create(ctx context.Context, in *CreateArgs, opts ...grpc.CallOption) (*CreateResult, error) {
	out := new(CreateResult)
	err := c.cc.Invoke(ctx, "/user.UserService/create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userServiceClient) Remove(ctx context.Context, in *RemoveArgs, opts ...grpc.CallOption) (*RemoveResult, error) {
	out := new(RemoveResult)
	err := c.cc.Invoke(ctx, "/user.UserService/remove", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userServiceClient) FindByID(ctx context.Context, in *FindByIDArgs, opts ...grpc.CallOption) (*FindByIDResult, error) {
	out := new(FindByIDResult)
	err := c.cc.Invoke(ctx, "/user.UserService/findByID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userServiceClient) FindByEmailAndPassword(ctx context.Context, in *FindByEmailAndPasswordArgs, opts ...grpc.CallOption) (*FindByEmailAndPasswordResult, error) {
	out := new(FindByEmailAndPasswordResult)
	err := c.cc.Invoke(ctx, "/user.UserService/findByEmailAndPassword", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userServiceClient) ChangeStatus(ctx context.Context, in *ChangeStatusArgs, opts ...grpc.CallOption) (*ChangeStatusResult, error) {
	out := new(ChangeStatusResult)
	err := c.cc.Invoke(ctx, "/user.UserService/changeStatus", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userServiceClient) ChangePass(ctx context.Context, in *ChangePassArgs, opts ...grpc.CallOption) (*ChangePassResult, error) {
	out := new(ChangePassResult)
	err := c.cc.Invoke(ctx, "/user.UserService/changePass", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// UserServiceServer is the server API for UserService service.
// All implementations must embed UnimplementedUserServiceServer
// for forward compatibility
type UserServiceServer interface {
	Create(context.Context, *CreateArgs) (*CreateResult, error)
	Remove(context.Context, *RemoveArgs) (*RemoveResult, error)
	FindByID(context.Context, *FindByIDArgs) (*FindByIDResult, error)
	FindByEmailAndPassword(context.Context, *FindByEmailAndPasswordArgs) (*FindByEmailAndPasswordResult, error)
	ChangeStatus(context.Context, *ChangeStatusArgs) (*ChangeStatusResult, error)
	ChangePass(context.Context, *ChangePassArgs) (*ChangePassResult, error)
	mustEmbedUnimplementedUserServiceServer()
}

// UnimplementedUserServiceServer must be embedded to have forward compatible implementations.
type UnimplementedUserServiceServer struct {
}

func (UnimplementedUserServiceServer) Create(context.Context, *CreateArgs) (*CreateResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedUserServiceServer) Remove(context.Context, *RemoveArgs) (*RemoveResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Remove not implemented")
}
func (UnimplementedUserServiceServer) FindByID(context.Context, *FindByIDArgs) (*FindByIDResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FindByID not implemented")
}
func (UnimplementedUserServiceServer) FindByEmailAndPassword(context.Context, *FindByEmailAndPasswordArgs) (*FindByEmailAndPasswordResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FindByEmailAndPassword not implemented")
}
func (UnimplementedUserServiceServer) ChangeStatus(context.Context, *ChangeStatusArgs) (*ChangeStatusResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ChangeStatus not implemented")
}
func (UnimplementedUserServiceServer) ChangePass(context.Context, *ChangePassArgs) (*ChangePassResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ChangePass not implemented")
}
func (UnimplementedUserServiceServer) mustEmbedUnimplementedUserServiceServer() {}

// UnsafeUserServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to UserServiceServer will
// result in compilation errors.
type UnsafeUserServiceServer interface {
	mustEmbedUnimplementedUserServiceServer()
}

func RegisterUserServiceServer(s grpc.ServiceRegistrar, srv UserServiceServer) {
	s.RegisterService(&UserService_ServiceDesc, srv)
}

func _UserService_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateArgs)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServiceServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.UserService/create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServiceServer).Create(ctx, req.(*CreateArgs))
	}
	return interceptor(ctx, in, info, handler)
}

func _UserService_Remove_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RemoveArgs)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServiceServer).Remove(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.UserService/remove",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServiceServer).Remove(ctx, req.(*RemoveArgs))
	}
	return interceptor(ctx, in, info, handler)
}

func _UserService_FindByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FindByIDArgs)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServiceServer).FindByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.UserService/findByID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServiceServer).FindByID(ctx, req.(*FindByIDArgs))
	}
	return interceptor(ctx, in, info, handler)
}

func _UserService_FindByEmailAndPassword_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FindByEmailAndPasswordArgs)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServiceServer).FindByEmailAndPassword(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.UserService/findByEmailAndPassword",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServiceServer).FindByEmailAndPassword(ctx, req.(*FindByEmailAndPasswordArgs))
	}
	return interceptor(ctx, in, info, handler)
}

func _UserService_ChangeStatus_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ChangeStatusArgs)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServiceServer).ChangeStatus(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.UserService/changeStatus",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServiceServer).ChangeStatus(ctx, req.(*ChangeStatusArgs))
	}
	return interceptor(ctx, in, info, handler)
}

func _UserService_ChangePass_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ChangePassArgs)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServiceServer).ChangePass(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.UserService/changePass",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServiceServer).ChangePass(ctx, req.(*ChangePassArgs))
	}
	return interceptor(ctx, in, info, handler)
}

// UserService_ServiceDesc is the grpc.ServiceDesc for UserService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var UserService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "user.UserService",
	HandlerType: (*UserServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "create",
			Handler:    _UserService_Create_Handler,
		},
		{
			MethodName: "remove",
			Handler:    _UserService_Remove_Handler,
		},
		{
			MethodName: "findByID",
			Handler:    _UserService_FindByID_Handler,
		},
		{
			MethodName: "findByEmailAndPassword",
			Handler:    _UserService_FindByEmailAndPassword_Handler,
		},
		{
			MethodName: "changeStatus",
			Handler:    _UserService_ChangeStatus_Handler,
		},
		{
			MethodName: "changePass",
			Handler:    _UserService_ChangePass_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "user.proto",
}
